/*
**  ComponentJS -- Component System for JavaScript <http://componentjs.com>
**  Copyright (c) 2009-2018 Ralf S. Engelschall <http://engelschall.com>
**
**  This Source Code Form is subject to the terms of the Mozilla Public
**  License (MPL), version 2.0. If a copy of the MPL was not distributed
**  with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
/*
 *  This is a ComponentJS plugin which integrates the awesome Vue
 *  library for view mask rendering and data binding.
 */
/* global ComponentJS: false */
/* global Vue: false */
/* global Event: false */
/* eslint no-unused-vars: 0 */
/* jshint unused: false */
/*  helper function for detecting jQuery object  */
var isjQuery=function(a){return"object"==typeof a&&"string"==typeof a.jquery&&null!==a.jquery.match(/^[0-9]+(?:\.[0-9]+)+$/)},isVue=function(a){return"object"==typeof a&&"boolean"==typeof a._isVue&&a._isVue===!0};/*  hook as a plugin into ComponentJS  */
ComponentJS.plugin("vue",function(a,b,c){/*  define the extra trait for components  */
var d=b.trait({protos:{/*  create a new Vue instance  */
vue:function(){/*  determine parameters  */
var c,d=this,e=b.params("vue",arguments,{options:{pos:0,req:!0},spool:{pos:1,def:null}});/*  prepare the HTML mask template  */
if("undefined"==typeof e.options.template&&"undefined"==typeof e.options.render)throw a.exception("vue",'missing mandatory Vue options "template" or "render"');if("undefined"!=typeof e.options.template&&(/*  unwrap jQuery wrapper object  */
isjQuery(e.options.template)&&(e.options.template=e.options.template.get(0)),"string"==typeof e.options.template)){for(;;){var f=e.options.template.replace(/^\s*<!--.*?-->\s*/,"");if(e.options.template===f)break;e.options.template=f}e.options.template=e.options.template.replace(/^\s+/,"").replace(/\s+$/,"")}for(/*  iterate over all ComponentJS models towards the root component and find all model values  */
var g,h,i={},j=this;null!==j&&(/*  find next component with a model  */
g=j.property({name:"ComponentJS:model",returnowner:!0}),a.isdefined(g));){h=g.property("ComponentJS:model"),j=g.parent();/*  remember all model values  */
for(var k in h.data)i[k]={owner:g,observers:!1}}var l=Object.keys(i);if(0===l.length)throw a.exception("vue","no models values found at all");/*  prepare Vue options  */
"object"!=typeof e.options.data&&(e.options.data={}),"object"!=typeof e.options.computed&&(e.options.computed={}),"object"!=typeof e.options.methods&&(e.options.methods={});/*  the Vue symbol prefix for ComponentJS trigger model values  */
var m="ComponentJS_trigger_";/*  provide Vue model entries for all ComponentJS model values  */
a.foreach(l,function(f){var g=f.replace(/[^a-zA-Z0-9_$]+/g,"_");if(g.match(/^event.+$/)||a.hook("ComponentJS:vue:modelisevent","or",g))/*  ComponentJS event values "eventXXX" are implemented as Vue methods  */
e.options.methods[g]=function(a){b(d).value(f,"object"==typeof a&&a instanceof Event||a)};else{var h=function(){/*  just update the Vue trigger value  */
c[m+g]++};/*  other ComponentJS values are implemented as Vue computed properties
                            with an associated trigger property for firing the invalidation
                            of the internal Vue caching mechanism by forcing a re-get operation  */
e.options.data[m+g]=0,e.options.computed[g]={get:function(){/*  get the underlying ComponentJS model value  */
/*  tell Vue that we are depending on our trigger value by just accessing
                                    it once (so we can later force Vue to call us again instead of using
                                    the cached value we returned beforehand). This operation is observed
                                    by Vue and leads to the dependency between the computed property and
                                    the trigger property  */
/*  lazy provide observers for the ComponentJS model values  */
return void this[m+g],i[f].observers||(a.foreach(["set","splice","delete"],function(a){var e=b(d).observe({name:f,op:a,func:h});c.__ComponentJS.observers.push(e)}),i[f].observers=!0),b(d).value(f)},set:function(e){/*  update the Vue trigger value to ensure that Vue
                                    is forced to update the cached value of the above getter  */
this[m+g]++,/*  lazy provide observers for the ComponentJS model values  */
i[f].observers||(a.foreach(["set","splice","delete"],function(a){var e=b(d).observe({name:f,op:a,func:h});c.__ComponentJS.observers.push(e)}),i[f].observers=!0),/*  set the underlying ComponentJS model value  */
b(d).value(f,e)}}}});/*  provide Vue trampoline methods for all ComponentJS
                    view component backing object utility methods "utilXXX"  */
var n=d.obj();if(null!==n)for(var o=a.state_methods(),p=n;null!==p;p=Object.getPrototypeOf(p)){var q=Object.getOwnPropertyNames(p);a.foreach(q,function(a){void 0===o[a]&&"function"==typeof p[a]&&a.match(/^util.+$/)&&(e.options.methods[a]=function(){return n[a].apply(n,arguments)})})}/*  hook into Vue instance life-cycle to destroy observers and sockets  */
e.options.beforeDestroy=function(){a.foreach(this.__ComponentJS.observers,function(a){b(d).unobserve(a)}),a.foreach(this.__ComponentJS.sockets,function(a){b(d).unsocket(a)})},/*  create Vue instance  */
c=new Vue(e.options),/*  attach ComponentJS information to Vue instance  */
c.__ComponentJS={observers:[],sockets:[]},/*  render into a still stand-alone DOM fragment  */
c.$mount();/*  automatically create ComponentJS sockets for all
                    DOM elements which are tagged as sockets  */
var r=function(a){var e=a.getAttribute("data-socket"),f="",g=e.match(/^(.*)@(.+)$/);null!==g&&(e=g[1],f=g[2]);var h={ctx:a};""!==e&&(h.name=e),""!==f&&(h.scope=f);var i=b(d).socket(h);c.__ComponentJS.sockets.push(i)};c.$el.hasAttribute("data-socket")&&r(c.$el);for(var s=c.$el.querySelectorAll("*[data-socket]"),t=0;t<s.length;t++)r(s[t]);/*  optionally spool Vue instance destruction  */
if(null!==e.spool){var u=a.spool_spec_parse(this,e.spool);u.comp.spool(u.name,this,function(a){a.$destroy()},c)}/*  return Vue model  */
return c},/*  destroy a Vue instance  */
unvue:function(c){/*  determine parameters  */
var d=b.params("unvue",arguments,{vm:{pos:0,req:!0}});/*  sanity check parameter  */
if(!isVue(d.vm))throw a.exception("unvue","invalid Vue instance");/*  destroy Vue instance  */
d.vm.$destroy()},/*  override the original ComponentJS socket() API method  */
socket:function(){/*  determine parameters  */
var a=b.params("socket",arguments,{name:{def:"default"},scope:{def:null},ctx:{pos:0,req:!0},plug:{pos:1,def:null},/*  removed "req: true"  */
unplug:{pos:2,def:null},/*  removed "req: true"  */
spool:{def:null}});/*  pass-through execution to original/base method  */
/*  provide specialized socket "plug" functionality  */
/*  provide specialized socket "unplug" functionality  */
return null===a.plug&&(a.plug=function(a){/*  on-the-fly get the HTML element from jQuery/Vue object  */
isjQuery(a)?a=a.get(0):isVue(a)&&(a=a.$el),/*  append it to the DOM tree (the jQuery or plain way)  */
isjQuery(this)?this.append(a):this.appendChild(a)}),null===a.unplug&&(a.unplug=function(a){/*  remove it from the DOM tree (the jQuery way)  */
if(isjQuery(a))a.detach();else{/*  on-the-fly get the HTML element from Vue object  */
isVue(a)&&(a=a.$el);/*  remove it from the DOM tree (the plain way)  */
var b=a.parentElement;null!==b&&b.removeChild(a)}}),this.base(a)}}});/*  mixin this trait to all components  */
a.latch("ComponentJS:bootstrap:comp:mixin",function(a){a.push(d)})});